unit ProDsg;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, ExtCtrls, ProEdit, ProBase, ProGrids, 
  StdCtrls, Ext3D, DsgnIntf, Menus, Clipbrd;

type
  TProDesigner = class(TForm)
    WorkGrid: TProGrid;
    ToolsPanel: TPanel;
    Around: TSpeedButton;
    Bottoms: TSpeedButton;
    Tops: TSpeedButton;
    Lefts: TSpeedButton;
    Rights: TSpeedButton;
    Inside: TSpeedButton;
    Horzs: TSpeedButton;
    Verts: TSpeedButton;
    Cut: TSpeedButton;
    Copy: TSpeedButton;
    Paste: TSpeedButton;
    RightText: TSpeedButton;
    LeftText: TSpeedButton;
    CenterText: TSpeedButton;
    TopText: TSpeedButton;
    MiddleText: TSpeedButton;
    BottomText: TSpeedButton;
    CellColor: TSpeedButton;
    BoldFont: TSpeedButton;
    ItalicFont: TSpeedButton;
    UnderFont: TSpeedButton;
    StrokedFont: TSpeedButton;
    CellBorder: TSpeedButton;
    Up3D: TSpeedButton;
    UpFlat: TSpeedButton;
    UpBump: TSpeedButton;
    DownBump: TSpeedButton;
    DownFlat: TSpeedButton;
    Down3D: TSpeedButton;
    DisableOnOff: TSpeedButton;
    HiddenOnOff: TSpeedButton;
    TextMode: TSpeedButton;
    FloatMode: TSpeedButton;
    LongMode: TSpeedButton;
    AddColumn: TSpeedButton;
    RemoveCol: TSpeedButton;
    AddRow: TSpeedButton;
    RemoveRow: TSpeedButton;
    SpinOnOff: TSpeedButton;
    None3D: TSpeedButton;
    TopFixedsOnOff: TSpeedButton;
    UniteOnOff: TSpeedButton;
    LeftFixedsOnOff: TSpeedButton;
    StatusPanel: TPanel;
    ButtonsPanel: TPanel;
    OK: TBitBtn;
    Apply: TBitBtn;
    Cancel: TBitBtn;
    SelRange: TLabel;
    WidthEdit: TProEdit;
    Label1: TLabel;
    Label2: TLabel;
    HeightEdit: TProEdit;
    ColorDialog: TColorDialog;
    DigitsEdit: TProEdit;
    LocalMenu: TPopupMenu;
    Default1: TMenuItem;
    Navigator1: TMenuItem;
    StylerFonts: TMenuItem;
    N1: TMenuItem;
    SetDefaults1: TMenuItem;
    ColumnWidth1: TMenuItem;
    RowHeight1: TMenuItem;
    N2: TMenuItem;
    N3: TMenuItem;
    Fill1: TMenuItem;
    Line1: TMenuItem;
    N4: TMenuItem;
    Reset1: TMenuItem;
    Color1: TMenuItem;
    Border1: TMenuItem;
    FontIndex1: TMenuItem;
    Value1: TMenuItem;
    procedure AddColumnClick(Sender: TObject);
    procedure AddRowClick(Sender: TObject);
    procedure RemoveColClick(Sender: TObject);
    procedure RemoveRowClick(Sender: TObject);
    procedure TopFixedsOnOffClick(Sender: TObject);
    procedure LeftFixedsOnOffClick(Sender: TObject);
    procedure WorkGridSelChanged(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FlagButtonClick(Sender: TObject);
    procedure HorzTextClick(Sender: TObject);
    procedure VertTextClick(Sender: TObject);
    procedure Frame3DClick(Sender: TObject);
    procedure WidthEditChanged(Sender: TObject);
    procedure HeightEditChanged(Sender: TObject);
    procedure HeightEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure WidthEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure CellColorClick(Sender: TObject);
    procedure AroundClick(Sender: TObject);
    procedure BottomsClick(Sender: TObject);
    procedure TopsClick(Sender: TObject);
    procedure LeftsClick(Sender: TObject);
    procedure RightsClick(Sender: TObject);
    procedure InsideClick(Sender: TObject);
    procedure VertsClick(Sender: TObject);
    procedure HorzsClick(Sender: TObject);
    procedure EditModeClick(Sender: TObject);
    procedure UniteOnOffClick(Sender: TObject);
    procedure DigitsEditChanged(Sender: TObject);
    procedure ApplyClick(Sender: TObject);
    procedure OKClick(Sender: TObject);
    procedure CancelClick(Sender: TObject);
    procedure Default1Click(Sender: TObject);
    procedure Navigator1Click(Sender: TObject);
    procedure ChangeFontClick(Sender: TObject);
    procedure ColumnWidth1Click(Sender: TObject);
    procedure RowHeight1Click(Sender: TObject);
    procedure Color1Click(Sender: TObject);
    procedure CutClick(Sender: TObject);
    procedure CopyClick(Sender: TObject);
    procedure PasteClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    FSelection: TProGridRect;
    FPosition: Boolean;
    FSizeProtect: Boolean;
    FMemory: TProGrid;

  public
    { Public declarations }
    FTransfer: TProGrid;
    FDesigner: TDesigner;

    procedure UpdateFonts;
    procedure UpdateAll;
    procedure UpdateSelection;
    procedure UpdateFlags;
    procedure UpdateSizes;
    procedure UpdateBorders;
    procedure UpdateEditTypes;
    procedure UpdateUnions;
    function  UpdateClipboard: Boolean;

    function  ScanFlags(AMask, AValue: Longint): Boolean;
    function  ScanOffsetFlags(AMask, AValue: Longint; OLeft, OTop, ORight, OBottom: Longint): Boolean;
    function  ScanRectFlags(AMask, AValue: Longint; const ARect: TProGridRect): Boolean;

    procedure SetFlags(AMask, AValue: Longint);
    procedure SetOffsetFlags(AMask, AValue: Longint; OLeft, OTop, ORight, OBottom: Longint);
    procedure SetRectFlags(AMask, AValue: Longint; const ARect: TProGridRect);

    procedure AcceptEditGrid(AFrom, ATo: TProGrid);
  end;

  TProGridEditor = class(TDefaultEditor)
  public
    procedure Edit; override;
  end;

  procedure Register;

implementation

{$R *.DFM}

  procedure Register;
  begin
    CompLib := True;
    RegisterComponents('Athena Pro', [TProGrid, TProEdit, TProNavigator, TProGridStyler]);
    RegisterComponentEditor(TProGrid, TProGridEditor);
  end;


{///TProGridEditor}

procedure TProGridEditor.Edit;
var PD: TProDesigner;
begin
    PD := TProDesigner.Create(Application);
    PD.FTransfer := TProGrid(Component);
    PD.AcceptEditGrid(PD.FTransfer, PD.WorkGrid);
    PD.FDesigner := Designer;
    PD.UpdateFonts;
    PD.UpdateClipboard;
    PD.ShowModal;
    PD.Free;
end;

{///7TProDesigner}

procedure TProDesigner.AddColumnClick(Sender: TObject);
begin
  WorkGrid.ColCount := WorkGrid.ColCount + 1;
end;

procedure TProDesigner.AddRowClick(Sender: TObject);
begin
  WorkGrid.RowCount := WorkGrid.RowCount + 1;
end;

procedure TProDesigner.RemoveColClick(Sender: TObject);
begin
  WorkGrid.ColCount := WorkGrid.ColCount - 1;
end;

procedure TProDesigner.RemoveRowClick(Sender: TObject);
begin
  WorkGrid.RowCount := WorkGrid.RowCount - 1;
end;

procedure TProDesigner.TopFixedsOnOffClick(Sender: TObject);
begin
  if TopFixedsOnOff.Down
  then WorkGrid.FixedRows := 1
  else WorkGrid.FixedRows := 0;
end;

procedure TProDesigner.LeftFixedsOnOffClick(Sender: TObject);
begin
  if LeftFixedsOnOff.Down
  then WorkGrid.FixedCols := 1
  else WorkGrid.FixedCols := 0;
end;

procedure TProDesigner.UpdateAll;
begin
  FSelection := WorkGrid.Selection;
  UpdateSelection;
  UpdateFlags;
  UpdateBorders;
  UpdateSizes;
  UpdateEditTypes;
  UpdateUnions;
end;

procedure TProDesigner.UpdateSelection;
begin
  with FSelection do
  begin
    FPosition := (Left = Right) and (Top = Bottom);
    if FPosition
    then SelRange.Caption := 'C: '  + IntToStr(Left)  + ', R: '    + IntToStr(Top)
    else SelRange.Caption := 'L: '  + IntToStr(Left)  + ', T: '    + IntToStr(Top) +
                           ', R: ' + IntToStr(Right) + ', B: ' + IntToStr(Bottom);
  end;
end;

procedure TProDesigner.UpdateFlags;
begin
  HiddenOnOff.Down := ScanFlags(csHidden, csHidden);
  DisableOnOff.Down:= ScanFlags(csDisabled, csDisabled);
  SpinOnOff.Down   := ScanFlags(cssSpin, cssSpin);

  BoldFont.Down    := ScanFlags(cfsBold, cfsBold);
  ItalicFont.Down  := ScanFlags(cfsItalic, cfsItalic);
  UnderFont.Down   := ScanFlags(cfsUnder, cfsUnder);
  StrokedFont.Down := ScanFlags(cfsStroked, cfsStroked);

  LeftText.AllowAllUp  := True;
  LeftText.Down    := ScanFlags(casHRight or casHCenter, 0);
  CenterText.Down  := ScanFlags(casHRight or casHCenter, casHCenter);
  RightText.Down   := ScanFlags(casHRight or casHCenter, casHRight);
  LeftText.AllowAllUp  := False;

  TopText.AllowAllUp  := True;
  TopText.Down     := ScanFlags(casVBottom or casVCenter, 0);
  MiddleText.Down  := ScanFlags(casVBottom or casVCenter, casVCenter);
  BottomText.Down  := ScanFlags(casVBottom or casVCenter, casVBottom);
  TopText.AllowAllUp  := False;

  Up3D.AllowAllUp  := True;
  Up3D.Down        := ScanFlags(cvsMask, Longint(esUp3D) shl 24);
  UpFlat.Down      := ScanFlags(cvsMask, Longint(esUpFlat) shl 24);
  UpBump.Down      := ScanFlags(cvsMask, Longint(esUpBump) shl 24);
  None3D.Down      := ScanFlags(cvsMask, 0);
  DownBump.Down    := ScanFlags(cvsMask, Longint(esDownBump) shl 24);
  DownFlat.Down    := ScanFlags(cvsMask, Longint(esDownFlat) shl 24);
  Down3D.Down      := ScanFlags(cvsMask, Longint(esDown3D) shl 24);
  Up3D.AllowAllUp  := False;

end;

procedure TProDesigner.UpdateBorders;
begin
  with FSelection do
  begin
    Rights.Down     := ScanOffsetFlags(cbsRight, cbsRight, Right, -1, -1, -1);
    Lefts.Down      := ScanOffsetFlags(cbsLeft, cbsLeft, -1, -1, Left, -1);
    Bottoms.Down    := ScanOffsetFlags(cbsBottom, cbsBottom, -1, Bottom, -1, -1);
    Tops.Down       := ScanOffsetFlags(cbsTop, cbsTop, -1, -1, -1, Top);

    ARound.Down     := Tops.Down and Bottoms.Down and Lefts.Down and Rights.Down;

    Horzs.Enabled   := Bottom > Top;
    Verts.Enabled   := Right > Left;
    Inside.Enabled  := Horzs.Enabled or Verts.Enabled;

    if Bottom > Top then
    begin
      Horzs.Enabled := True;
      Horzs.Down    := ScanOffsetFlags(cbsBottom, cbsBottom, -1, -1, -1, Bottom - 1);
    end else
    begin
      Horzs.Down    := False;
      Horzs.Enabled := False;
    end;

    if Right > Left then
    begin
      Verts.Enabled := True;
      Verts.Down    := ScanOffsetFlags(cbsRight, cbsRight, -1, -1, Right - 1, -1);
    end else
    begin
      Verts.Down    := False;
      Verts.Enabled := False;
    end;

    Inside.Down     := Horzs.Down and Verts.Down;
    Inside.Enabled  := Horzs.Enabled or Verts.Enabled;
  end;
end;

procedure TProDesigner.WorkGridSelChanged(Sender: TObject);
begin
  UpdateAll;
end;

procedure TProDesigner.FormCreate(Sender: TObject);
begin
  DigitsEdit.SpinVisible := True;
  WidthEdit.SpinVisible := True;
  HeightEdit.SpinVisible := True;
  UpdateAll;
end;

function  TProDesigner.ScanFlags(AMask, AValue: Longint): Boolean;
begin
  Result := ScanRectFlags(AMask, AValue, FSelection);
end;

function  TProDesigner.ScanOffsetFlags(AMask, AValue: Longint; OLeft, OTop, ORight, OBottom: Longint): Boolean;
var FArea: TProGridRect;
begin
  FArea := FSelection;
  if OLeft >= 0 then FArea.Left     := OLeft;
  if OTop >= 0 then FArea.Top       := OTop;
  if ORight >= 0 then FArea.Right   := ORight;
  if OBottom >= 0 then FArea.Bottom := OBottom;
  Result := ScanRectFlags(AMask, AValue, FArea);
end;

function  TProDesigner.ScanRectFlags(AMask, AValue: Longint; const ARect: TProGridRect): Boolean;
var X, Y: Longint;
begin
  Result := False;
  for X := ARect.Left to ARect.Right  do
  for Y := ARect.Top  to ARect.Bottom do
  if (WorkGrid.Styles[X, Y] and AMask) <> AValue then exit;
  Result := True;
end;

procedure TProDesigner.SetFlags(AMask, AValue: Longint);
begin
  SetRectFlags(AMask, AValue, FSelection);
end;

procedure TProDesigner.SetOffsetFlags(AMask, AValue: Longint; OLeft, OTop, ORight, OBottom: Longint);
var FArea: TProGridRect;
begin
  FArea := FSelection;
  if OLeft >= 0 then FArea.Left     := OLeft;
  if OTop >= 0 then FArea.Top       := OTop;
  if ORight >= 0 then FArea.Right   := ORight;
  if OBottom >= 0 then FArea.Bottom := OBottom;
  SetRectFlags(AMask, AValue, FArea);
end;

procedure TProDesigner.SetRectFlags(AMask, AValue: Longint; const ARect: TProGridRect);
var X, Y, Style: Longint;
begin
  with WorkGrid do
  for X := ARect.Left to ARect.Right  do
  for Y := ARect.Top  to ARect.Bottom do
    Styles[X, Y] := (Styles[X, Y] and not AMask) or AValue;
end;

procedure TProDesigner.FlagButtonClick(Sender: TObject);
begin
  with TSpeedButton(Sender) do
  if Down
  then SetFlags(Tag, Tag)
  else SetFlags(Tag, 0);
end;

procedure TProDesigner.HorzTextClick(Sender: TObject);
begin
  with TSpeedButton(Sender) do
    SetFlags(Tag or casHRight or casHCenter, Tag);
end;

procedure TProDesigner.VertTextClick(Sender: TObject);
begin
  with TSpeedButton(Sender) do
    SetFlags(Tag or casVBottom or casVCenter, Tag);
end;

procedure TProDesigner.Frame3DClick(Sender: TObject);
begin
  with TSpeedButton(Sender) do
    SetFlags(cvsMask, Tag shl 24);
end;

procedure TProDesigner.UpdateSizes;
var I, SX, SY : Integer;
begin
  with WorkGrid, FSelection do
  begin
  FSizeProtect := True;

  SX := Abs(ColWidths[Left]);
  SY := Abs(RowHeights[Top]);
  WidthEdit.Font.Color := clBlack;
  HeightEdit.Font.Color := clBlack;

  for I := Left + 1 to Right do
  if Abs(ColWidths[I]) <> SX then
  begin
    WidthEdit.Font.Color := clRed;
    Break;
  end;

  for I := Top + 1 to Bottom do
  if Abs(RowHeights[I]) <> SY then
  begin
    HeightEdit.Font.Color := clRed;
    Break;
  end;

  WidthEdit.ValLong := SX;
  HeightEdit.ValLong := SY;

  FSizeProtect := False;
  end;
end;

procedure TProDesigner.WidthEditChanged(Sender: TObject);
var I, SX : Integer;
begin
  with WorkGrid,FSelection do
  begin
    if FSizeProtect then exit;
    SX := WidthEdit.ValLong;
    if SX < 1 then exit;
    for I := Left to Right do
    ColWidths[I] := SX;
  end;
  UpdateSizes;
end;

procedure TProDesigner.HeightEditChanged(Sender: TObject);
var I, SY : Integer;
begin
  with WorkGrid,FSelection do
  begin
    if FSizeProtect then exit;
    SY := HeightEdit.ValLong;
    if SY < 1 then exit;
    for I := Top to Bottom do
    RowHeights[I] := SY;
  end;
  UpdateSizes;
end;

procedure TProDesigner.HeightEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN
  then HeightEditChanged(Sender);
end;

procedure TProDesigner.WidthEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_RETURN
  then WidthEditChanged(Sender);
end;

procedure TProDesigner.CellColorClick(Sender: TObject);
var I, J: Integer;
begin
  with WorkGrid, FSelection do
  begin
    if TComponent(Sender).Tag = 0
    then ColorDialog.Color := Colors[Left, Top]
    else ColorDialog.Color := Borders[Left, Top];
    if ColorDialog.Execute then
    for I := Left to Right do
    for J := Top to Bottom do
    begin
      if TComponent(Sender).Tag = 0
      then Colors[I, J] := ColorDialog.Color
      else Borders[I, J] := ColorDialog.Color;
    end;
  end;
end;

procedure TProDesigner.AroundClick(Sender: TObject);
begin
  with TSpeedButton(Sender) do
  begin
    Bottoms.Down := Down; BottomsClick(Sender);
    Tops.Down    := Down; TopsClick(Sender);
    Rights.Down  := Down; RightsClick(Sender);
    Lefts.Down   := Down; LeftsClick(Sender);
  end;
  UpdateBorders;
end;

procedure TProDesigner.BottomsClick(Sender: TObject);
var I: Longint;
begin
  with WorkGrid do
  begin
    for I := FSelection.Left to FSelection.Right do
    Style[I, FSelection.Bottom, cbsBottom] := TSpeedButton(Sender).Down
  end;
  if Sender = Bottoms then UpdateBorders;
end;

procedure TProDesigner.TopsClick(Sender: TObject);
var I: Longint;
begin
  with WorkGrid do
  begin
    for I := FSelection.Left to FSelection.Right do
    Style[I, FSelection.Top, cbsTop] := TSpeedButton(Sender).Down;
  end;
  if Sender = Tops then UpdateBorders;
end;

procedure TProDesigner.LeftsClick(Sender: TObject);
var I: Longint;
begin
  with WorkGrid do
  begin
    for I := FSelection.Top to FSelection.Bottom do
    Style[FSelection.Left, I, cbsLeft] := TSpeedButton(Sender).Down;
  end;
  if Sender = Lefts then UpdateBorders;
end;

procedure TProDesigner.RightsClick(Sender: TObject);
var I: Longint;
begin
  with WorkGrid do
  begin
    for I := FSelection.Top to FSelection.Bottom do
    Style[FSelection.Right, I, cbsRight] := TSpeedButton(Sender).Down;
  end;
  if Sender = Rights then UpdateBorders;
end;

procedure TProDesigner.InsideClick(Sender: TObject);
begin
  with TSpeedButton(Sender) do
  begin
    if Horzs.Enabled then
    begin
      Horzs.Down := Down;
      HorzsClick(Sender);
    end;
    if Verts.Enabled then
    begin
      Verts.Down := Down;
      VertsClick(Sender);
    end;
  end;
  UpdateBorders;
end;

procedure TProDesigner.VertsClick(Sender: TObject);
begin
  if TSpeedButton(Sender).Down
  then SetOffsetFlags(cbsRight, cbsRight, -1, -1, FSelection.Right - 1, -1)
  else begin
         SetOffsetFlags(cbsRight, 0, -1, -1, FSelection.Right - 1, -1);
         SetOffsetFlags(cbsLeft, 0, FSelection.Left + 1, -1, -1, -1);
       end;
  if Sender = Verts then UpdateBorders;
end;

procedure TProDesigner.HorzsClick(Sender: TObject);
begin
  if TSpeedButton(Sender).Down
  then SetOffsetFlags(cbsBottom, cbsBottom, -1, -1, -1, FSelection.Bottom - 1)
  else begin
         SetOffsetFlags(cbsBottom, 0, -1, -1, -1, FSelection.Bottom - 1);
         SetOffsetFlags(cbsTop, 0, -1, FSelection.Top + 1, -1, -1);
       end;
  if Sender = Horzs then UpdateBorders;
end;

procedure TProDesigner.UpdateEditTypes;
var X, Y : Longint;
    ET   : TProEditType;
    PB   : TSpeedButton;
    DC   : Integer;
begin
  with WorkGrid, FSelection do
  begin
    ET := Types[Left, Top];
    case ET of
      etString: PB := TextMode;
      etFloat : PB := FloatMode;
      else PB := LongMode;
    end;
    DC := Digits[Left, Top];

    DigitsEdit.Font.Color := clBlack;

    PB.Down := True;

    for X := Left to Right do
    for Y := Top to Bottom do
    begin
      if (DC <> Digits[Left, Top]) and (ET = etFloat)
      then DigitsEdit.Font.Color := clRed;
      if Types[X, Y] <> ET then
      begin
        PB.AllowAllUp      := True;
        PB.Down            := False;
        PB.AllowAllUp      := False;
        DigitsEdit.Visible := False;
        exit;
      end;
    end;

    if ET = etFloat then
    begin
      FSizeProtect := True;
      DigitsEdit.Visible := True;
      DigitsEdit.ValLong := DC;
      FSizeProtect := False;
    end else DigitsEdit.Visible := False;
  end;
end;

procedure TProDesigner.EditModeClick(Sender: TObject);
var X, Y : Longint;
    ET   : TProEditType;
begin
  ET := TProEditType(TSpeedButton(Sender).Tag);
  with WorkGrid, FSelection do
  for X := Left to Right do
  for Y := Top to Bottom do
  begin
    if Types[X, Y] <> ET then
    case ET of
      etString: Texts[X, Y] := '';
      etFloat : Reals[X, Y] := 0.0;
      else Longs[X, Y] := 0;
    end;
  end;
  UpdateEditTypes;
end;

procedure TProDesigner.UpdateUnions;

function UnitedExist: Boolean;
var X,Y: Longint;
begin
  Result := True;
  with WorkGrid, FSelection do
  for X := Left to Right do
  for Y := Top to Bottom do
  if (Styles[X, Y] and ccsMask) <> 0 then exit;
  Result := False;
end;

begin
  with FSelection do
  if FPosition
  then begin
         UniteOnOff.Down := WorkGrid.Style[Left, Top, cnsLarge];
         UniteOnOff.Enabled := WorkGrid.Style[Left, Top, cnsLarge];
       end
  else if UnitedExist then
       begin
         UniteOnOff.Down := False;
         UniteOnOff.Enabled := False;
       end else
       begin
         UniteOnOff.Enabled := True;
         UniteOnOff.Down := False;
       end;
end;

procedure TProDesigner.UniteOnOffClick(Sender: TObject);
var FArea: TProGridRect;
begin
  FArea := FSelection;
  with WorkGrid, FSelection do
  begin
    if not TSpeedButton(Sender).Down
    then Sizes[Left, Top] := Point(0,0)
    else Sizes[Left, Top] := Point(FArea.Right - FArea.Left, FArea.Bottom - FArea.Top);
    BottomRight := TopLeft;
    Selection := FSelection;
  end;
  UpdateUnions;
end;

procedure TProDesigner.DigitsEditChanged(Sender: TObject);
var X, Y: Integer;
begin
  if FSizeProtect then exit;
  with WorkGrid, FSelection do
  for X := Left to Right do
  for Y := Top to Bottom do
    Digits[X, Y] := DigitsEdit.ValLong;
end;

procedure TProDesigner.AcceptEditGrid;
begin
  ATo.Assign(AFrom);
end;

procedure TProDesigner.ApplyClick(Sender: TObject);
var M: TProGrid;
begin
  AcceptEditGrid(WorkGrid, FTransfer);
  if Assigned(FDesigner) then FDesigner.Modified;
  M := TProGrid.Create(FTransfer.Owner);
  AcceptEditGrid(WorkGrid, M);
end;

procedure TProDesigner.OKClick(Sender: TObject);
begin
  ApplyClick(Self);
  Close;
end;

procedure TProDesigner.CancelClick(Sender: TObject);
begin
  Close;
end;

procedure TProDesigner.Default1Click(Sender: TObject);
begin
   if FPosition then
   with FSelection do
   WorkGrid.DefStyle := WorkGrid.Styles[Left, Top];
end;

procedure TProDesigner.Navigator1Click(Sender: TObject);
var N: TProNavigator;
begin
  N := TProNavigator.Create(Nil);
  N.ProGrid := FTransfer;
  N.Area := FSelection;
  N.Name := 'ProNav'+IntToStr(N.AreaLeft)+'_'+IntToStr(N.AreaTop);
  FTransfer.Owner.InsertComponent(N);
end;

procedure TProDesigner.UpdateFonts;
var I,C: Integer;
    M  : TMenuItem;
    S  : String;
    F  : TFont;
begin
  if (WorkGrid.GridStyler <> Nil) and (WorkGrid.GridStyler.Count > 1) then
  begin
    with WorkGrid.GridStyler do
    begin
      StylerFonts.Enabled := True;
      for I := 0 to Count - 1 do
      begin
        if I = 0
        then F := WorkGrid.Font
        else F := Fonts[I];
        ColorToIdent(F.Color, S);
        M := TMenuItem.Create(StylerFonts);
        M.Caption := IntToStr(I)+ ': ' + F.Name + ', ' + S + ', ' + IntToStr(F.Size);
        M.Tag := I;
        M.OnClick := ChangeFontClick;
        StylerFonts.Insert(I, M);
      end;
      if Count > 0 then
      begin
        M := TMenuItem.Create(StylerFonts);
        M.Caption := '-';
        StylerFonts.Insert(1, M);
      end;
    end;
  end else
  StylerFonts.Enabled := False;
end;

procedure TProDesigner.ChangeFontClick(Sender: TObject);
var I, J: Longint;
begin
  with WorkGrid, FSelection do
  for I := Left to Right do
  for J := Top to Bottom do
  Fonts[I, J] := TMenuItem(Sender).Tag;
end;

procedure TProDesigner.ColumnWidth1Click(Sender: TObject);
begin
  WorkGrid.DefaultColWidth := WorkGrid.ColWidths[FSelection.Left];
end;

procedure TProDesigner.RowHeight1Click(Sender: TObject);
begin
  WorkGrid.DefaultRowHeight := WorkGrid.RowHeights[FSelection.Top];
end;

procedure TProDesigner.Color1Click(Sender: TObject);
var I, J: Longint;
begin
  with WorkGrid, FSelection do
  for I := Left to Right do
  for J := Top to Bottom do
  Style[I, J, TComponent(Sender).Tag] := False;
end;

function TProDesigner.UpdateClipboard: Boolean;
var F1, F2: TMemoryStream;
    Size  : Longint;
begin
  FMemory.Free;
  FMemory := Nil;
  try
   try
    F1 := TMemoryStream.Create;
    F2 := TMemoryStream.Create;
    F1.SetSize(64000);
    Clipboard.GetTextBuf(PChar(F1.Memory), 32000);
    Size := StrLen(F1.Memory);
    if Size > 0 then
    begin
      F1.SetSize(Size+1);
      Clipboard.GetTextBuf(PChar(F1.Memory), Size+1);
      ObjectTextToBinary(F1, F2);
      F2.Seek(0,0);
      FMemory := TProGrid(F2.ReadComponent(Nil));
    end;
   finally
     F1.Free;
     F2.Free;
   end;
  except
  end;
  Result := FMemory <> Nil;
  Paste.Enabled := Result;
end;

procedure TProDesigner.CutClick(Sender: TObject);
var I,J: Longint;
begin
  CopyClick(Sender);
  with WorkGrid, FSelection do
  for I := Left to Right do
  for J := Top to Bottom do
  begin
    Styles[I, J] := DefStyle;
    Texts[I,J] := '';
  end;
  UpdateAll;
end;

procedure TProDesigner.CopyClick(Sender: TObject);
var M: TProGrid;
    F1,
    F2: TMemoryStream;
begin
  with FSelection do
  begin
    FMemory.Free;
    FMemory := Nil;
    FMemory := TProGrid.Create(nil);
    FMemory.Name := FTransfer.Name+'_Copy';
    FMemory.FixedCols := 0;
    FMemory.FixedRows := 0;
    FMemory.ColCount := Right - Left + 1;
    FMemory.RowCount := Bottom - Top + 1;
    FMemory.AssignFrom(0,0, WorkGrid, FSelection);
    F1 := TMemoryStream.Create;
    F2 := TMemoryStream.Create;
    F1.WriteComponent(FMemory);
    F1.Seek(0,0);
    ObjectBinaryToText(F1, F2);
    F1.Free;
    F1 := Nil;
    F2.Write(F1, 1);
    Clipboard.SetTextBuf(PChar(F2.Memory));
    F2.Free;
  end;
  UpdateClipboard;
end;

procedure TProDesigner.PasteClick(Sender: TObject);
var R: TProGridRect;
    I, J: Longint;
begin
  if UpdateClipboard then
  begin
    with FSelection do
    begin
      R.Left := 0;
      R.Top  := 0;
      R.Right := FMemory.ColCount - 1;
      R.Bottom := FMemory.RowCount - 1;
      if R.Right > WorkGrid.ColCount - 1 then R.Right := WorkGrid.ColCount - 1;
      if R.Bottom > WorkGrid.RowCount - 1 then R.Bottom := WorkGrid.RowCount - 1;
      for I := Left to Left + R.Right do
      for J := Top  to Top + R.Bottom do
      if WorkGrid.Style[I, J, cnsLarge]
      then WorkGrid.Sizes[I,J] := Point(0,0);
      WorkGrid.AssignFrom(Left, Top, FMemory, R);
      Inc(R.Left, Left);
      Inc(R.Right, Left);
      Inc(R.Top, Top);
      Inc(R.Bottom, Top);
      WorkGrid.Selection := R;
    end;
  end;
end;

procedure TProDesigner.FormDestroy(Sender: TObject);
begin
  FMemory.Free;
end;

begin
  RegisterClass(TProGrid);
end.

